//
//  ViewController.m
//  DashboardDemo
//
//  Created by sunhong on 16/8/8.
//  Copyright © 2016年 sunhong. All rights reserved.
//

#import "ViewController.h"

#import "LXCircleAnimationView.h"
#import "UIView+Extensions.h"

#import "GradientView.h"

#define SCREEN_WIDTH ([[UIScreen mainScreen] bounds].size.width)
#define SCREEN_HEIGHT ([[UIScreen mainScreen] bounds].size.height)

@interface ViewController ()

@property (nonatomic, strong) LXCircleAnimationView *circleProgressView;

@property (nonatomic, strong) GradientView * gradientView;

@property (nonatomic, strong) UIButton * clickBtn;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    [self setupGradientView];
    [self setupCircleView];
    
    UIButton *stareButton = [UIButton buttonWithType:UIButtonTypeCustom];
    stareButton.frame = CGRectMake(10.f, self.circleProgressView.bottom + 50.f, SCREEN_WIDTH - 20.f, 38.f);
    [stareButton addTarget:self action:@selector(onStareButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    [stareButton setTitle:@"Stare Animation" forState:UIControlStateNormal];
    [stareButton setBackgroundColor:[UIColor lightGrayColor]];
    stareButton.layer.masksToBounds = YES;
    stareButton.layer.cornerRadius = 4.f;
    [self.view addSubview:stareButton];
    
    _clickBtn = stareButton;
}

- (void)setupGradientView {
    self.gradientView = [[GradientView alloc] initWithFrame:self.view.bounds];
    [self.view addSubview:self.gradientView];
}

- (void)setupCircleView {
    self.circleProgressView = [[LXCircleAnimationView alloc] initWithFrame:CGRectMake(40.f, 70.f, SCREEN_WIDTH - 80.f, SCREEN_WIDTH - 80.f)];
    self.circleProgressView.bgImage = [UIImage imageNamed:@"backgroundImage"];
    self.circleProgressView.percent = 0.f;
    [self.view addSubview:self.circleProgressView];
}

- (void)onStareButtonClick:(UIButton *)sender {
    
    if (sender.selected) {
        [self.gradientView removeFromSuperview];
        self.gradientView = nil;
        [self.circleProgressView removeFromSuperview];
        self.circleProgressView = nil;
        
        [self setupGradientView];
        [self setupCircleView];
        
        [self.view bringSubviewToFront:self.clickBtn];
    }
    sender.selected = YES;
    
    self.circleProgressView.percent = 90.f;
    self.gradientView.percent = 90.f;
    
    [self.circleProgressView refreshJumpNOFromNO:@"100" toNO:@"693"];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
